/*
	CsvGrid.cpp

	Copyright(C) 2011, ()GCRbg All rights reserved.

	1.\[XR[h`łoCi`łAύX̗LɊւ炸A
	@ȉ̏𖞂ɂāAĔzzїp܂B

	@1-1.\[XR[h`ōĔzzꍇAL쌠\A {
	@@@ё2̐ӔCKK܂߂ĂB

	@1-2.oCi`ōĔzzꍇAL쌠\A {
	@@@LӔCKAzzƂƂɒ񋟂镶/܂
	@@@̎ɕK܂߂ĂB

	2.{\tgEFA͖ۏ؂łBȐӔCŎgpĂB
 */

#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <stdio.h>
#include <Clipbrd.hpp>

#include "CsvGrid.h"
#include "EncodeDetect.hpp"
//---------------------------------------------------------------------------
static struct {
	int codepage;
	TCHAR *str;
} st_enc_tab[] = {
	UCIO_SJIS,		_T("Shift_JIS"),
	UCIO_EUC,		_T("EUC_JP"),
	UCIO_JIS,		_T("JIS"),
	UCIO_UTF7,		_T("UTF-7"),
	UCIO_UTF8,		_T("UTF-8"),
	UCIO_UTF16,		_T("UTF-16"),
	UCIO_UTF16BE,	_T("UTF-16BE"),
};
static int st_num_enc_tab = sizeof(st_enc_tab)/sizeof(st_enc_tab[0]);

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// CChnageCursor - J[\̕ύXƕA
//---------------------------------------------------------------------------
class CChangeCursor
{
private:
	TCursor OldCursor;
public:
	CChangeCursor(TCursor cursor)
	{
		OldCursor = Screen->Cursor;
		Screen->Cursor = cursor;
	}
	~CChangeCursor()
	{
		Screen->Cursor = OldCursor;
	}
};

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//	class TCsvGrid : public TAcotGrid
//---------------------------------------------------------------------------
__fastcall TCsvGrid::TCsvGrid(TComponent* Owner)
	: TAcotGrid(Owner)
{
	SepChar = _T(',');
	EndOfLine = _T("\r\n");
}
//---------------------------------------------------------------------------
__fastcall TCsvGrid::~TCsvGrid()
{
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::Find(TFindDialog *dlg)
{
	if (dlg == NULL)
		return false;

	if (Find_a(dlg))
		return true;

	UnicodeString s;
	s.printf(_T("\"%s\" ܂B"), dlg->FindText.c_str());
	MessageDlg(s,mtInformation,TMsgDlgButtons() << mbOK,0);
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::Find_a(TFindDialog *dlg)
{
	UnicodeString text = dlg->FindText;
	if (!dlg->Options.Contains(frMatchCase))
		text = text.UpperCase();

	TGridRect gr = Selection;
	TInplaceEdit *ed = InplaceEditor;
	int start = 1;
	if (ed != NULL && EditorMode) {
		start = ed->SelStart + ed->SelLength + 1;
	}
	if (gr.Left < 1)
		gr.Left = 1;
	if (gr.Top < 1)
		gr.Top = 1;
	UnicodeString s;
	int col = gr.Left;
	while (col >= 1 && col < ColCount) {
		int row = gr.Top;
		while (row >= 1 && row < RowCount) {
			s = Cells[col][row];
			if (start > 1)
				s = s.SubString(start, s.Length()-start+1);
			if (!dlg->Options.Contains(frMatchCase))
				s = s.UpperCase();
			int ipos = s.Pos(text);
			if (ipos > 0) {
				if (start > 1)
					ipos += (start - 1);
				if (col < LeftCol)
					LeftCol = col;
				else while (col >= (LeftCol+VisibleColCount)) {
					if (VisibleColCount <= 0) {
						LeftCol = col;
						break;
					}
					LeftCol = col - VisibleColCount + 1;
				}
				if (row < TopRow)
					TopRow = row;
				else while (row >= (TopRow+VisibleRowCount)) {
					if (VisibleRowCount <= 0) {
						TopRow = row;
						break;
					}
					TopRow = row - VisibleRowCount + 1;
				}
				CellEdit = false;
				gr.Left = col;
				gr.Top = row;
				gr.Right = col;
				gr.Bottom = row;
				Selection = gr;
				CellEdit = true;
				ed = InplaceEditor;
				if (ed != NULL) {
					ed->SelStart = ipos - 1;
					ed->SelLength = text.Length();
					ed->SetFocus();
				}
				return true;
			}
			start = 1;
			if (dlg->Options.Contains(frDown))
				row++;
			else
				row--;
		}
		if (dlg->Options.Contains(frDown)) {
			col++;
			gr.Top = 1;
		} else {
			col--;
			gr.Top = RowCount - 1;
		}
	}
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::Replace(TReplaceDialog *dlg)
{
	if (dlg == NULL)
		return false;
	if (dlg->Options.Contains(frReplaceAll)) {
		TGridRect gr;
		gr.Left = gr.Right = gr.Top = gr.Bottom = 1;
		Selection = gr;
		while (Find_a(dlg)) {
			Replace_a(dlg);
		}
		return true;
	}

	if (dlg->Options.Contains(frReplace)) {
		Replace_a(dlg);
		return Find(dlg);
	}
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::Replace_a(TReplaceDialog *dlg)
{
	TInplaceEdit *ed = InplaceEditor;
	if (ed == NULL)
		return false;
	if (ed->SelLength <= 0 || ed->SelStart < 0)
		return false;
	UnicodeString s = ed->EditText;
	int idx = ed->SelStart+1;
	int len = ed->SelLength;
	if (dlg->FindText.CompareIC(s.SubString(idx, len)) != 0)
		return false;
	s.Delete(idx, len);
	s.Insert(dlg->ReplaceText, idx);
	ed->EditText = s;
	ed->SelStart = idx - 1;
	ed->SelLength = dlg->ReplaceText.Length();
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::IsEmpty()
{
	return FileName.Length() == 0 && GetModCount() == 0;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::CanClose()
{
	if (GetModCount() == 0)
		return true;
	// ύXj܂H
	if (MessageDlg(_T("ύXj܂B낵łH"),
				mtConfirmation,
				TMsgDlgButtons() << mbYes << mbNo,
				0) == mrYes) {
		return true;
	}
	return false;
}
//---------------------------------------------------------------------------
bool __fastcall TCsvGrid::CsvGetLine(
					const UnicodeString &str, // 镶
					int idx, // JnCfbNX
					TStringList *data, // J̃f[^
					TCHAR sepch, // ؂蕶
					int &cnt // vf
				)
{
	UnicodeString xstr;
	int ncol = 0;
	TCHAR *p_start = str.c_str() + idx - 1; // UnicodeString ̐擪 1
	TCHAR *p_end = str.c_str() + str.Length();
	TCHAR *p = p_start;
	while (p < p_end) {
		int n = GetCsvColumn(p, xstr, sepch);
		data->Add(xstr);
		xstr.SetLength(0);
		ncol++;
		p += n;
		if (p[0] == _T('\r') && p[1] == _T('\n')) {
			p += 2;
			EndOfLine = _T("\r\n");
			break;
		}
		if (p[0] == _T('\n') || p[0] == _T('\r')) {
			p++;
			EndOfLine = p[0];
			break;
		}
		p++;
	}
	cnt = p - p_start;
	return ncol > 0;
}
//---------------------------------------------------------------------------
int __fastcall TCsvGrid::ReadCsv(
					const UnicodeString &filename, int encidx)
{
	// return : file size, < 0 = G[
	CChangeCursor change_cur(crHourGlass);
	int rtn = -1;
	TBytes buf;
	try {
		TFileStream *fileStream = new TFileStream(filename, fmOpenRead);
		// TCY̑傫̂͏Ȃ
		if (fileStream->Size > 100000000) {
			delete fileStream;
			throw _T("Too Big");
		}
		buf.Length = fileStream->Size;
		if (fileStream->Read(&buf[0], buf.Length) != buf.Length) {
			delete fileStream;
			throw _T("Read Error");
		}
		delete fileStream;
		rtn = buf.Length;
	}
	catch (EFOpenError &e) {
		ShowMessage(e.Message);
	}
	catch (const TCHAR *e) {
		ShowMessage(e);
	}
	catch (int e) {
		ShowMessage(e);
	}
	catch (...) {
		ShowMessage(_T("File Read Error"));
	}
	if (rtn < 0)
		return rtn;

	int cpage; // R[hy[W
	if (encidx < 0 || encidx >= st_num_enc_tab) {
		switch (CheckEncoding(&buf[0], buf.Length)) {
			case ENC_SJIS: cpage = UCIO_SJIS; break;
			case ENC_EUC: cpage = UCIO_EUC; break;
			case ENC_JIS: cpage = UCIO_JIS; break;
			case ENC_UTF16LE: cpage = UCIO_UTF16; break;
			case ENC_UTF16BE: cpage = UCIO_UTF16BE; break;
			case ENC_UTF8: cpage = UCIO_UTF8; break;
			case ENC_UTF8BOM: cpage = UCIO_UTF8; break;
			case ENC_UTF7: cpage = UCIO_UTF7; break;
			default: cpage = -1;

		}
	} else {
		cpage = st_enc_tab[encidx].codepage;
	}
	if (cpage < 0) {
		ShowMessage(_T("Unknown Code Page"));
		return rtn;
	}

	// fR[h
	UnicodeString str;
	if (cpage == UCIO_UTF16) {
		str = TEncoding::Unicode->GetString(buf);
	} else if (cpage == UCIO_UTF16BE) {
		str = TEncoding::BigEndianUnicode->GetString(buf);
	} else {
		TEncoding *aEnc = TEncoding::GetEncoding(cpage);
		str = aEnc->GetString(buf);
		delete aEnc;
	}
	rtn = buf.Length;
	buf.Length = 0; // [̉

	// CSV؂蕶̔
	SepChar = JudgeSepChar(str);

	int nrow = 0;
	int ncol = 0;
	TStringList *data = new TStringList;
	for (int i = 1; i <= str.Length(); ) {
		int cnt;
		if (!CsvGetLine(str, i, data, SepChar, cnt))
			break;
		nrow++;
		if (ncol < data->Count) {
			ncol = data->Count;
			if (ColCount <= ncol)
				ColCount = ncol + 1;
		}
		if (RowCount <= nrow)
			RowCount = nrow + 1;
		for (int k = 0; k < data->Count; k++)
			Cells[k+1][nrow] = data->Strings[k];
		data->Clear();
		i += cnt;
	}
	delete data;
	if (nrow == 0 || ncol == 0) {
		ShowMessage(_T("No Data"));
		return -1;
	}
	if (ColCount != (ncol + 1))
		ColCount = ncol + 1;
	if (RowCount != (nrow + 1))
		RowCount = nrow + 1;

	FileName = filename;
	EncIndex = encidx;
	CodePage = cpage;

	return rtn;
}
//---------------------------------------------------------------------------
int __fastcall TCsvGrid::Save()
{
	// return : file size, < 0 = G[
	int rtn = SaveAs(FileName, EncIndex);
	if (rtn >= 0) {
		ResetModCount();
	}
	return rtn;
}
//---------------------------------------------------------------------------
int __fastcall TCsvGrid::SaveAs(
					const UnicodeString &filename, int encidx)
{
	// return : file size, < 0 = G[
	int rtn = -1;
	int maxrow = 0;
	int maxcol = 0;
	for (int row = 1; row < RowCount; row++) {
		int col;
		for (col = ColCount - 1; col >= 1; col--) {
			if (!Cells[col][row].IsEmpty())
				break;
		}
		if (col < 1)
			continue;
		if (col > maxcol)
			maxcol = col;
		maxrow = row;
	}
	if (maxrow <= 0) {
		ShowMessage(_T("No Data"));
		return rtn;
	}

	// GR[h
	int cpage = UCIO_SJIS;
	TEncoding *aEnc, *bEnc = NULL;
	if (encidx >= 0 && encidx < st_num_enc_tab)
		cpage = st_enc_tab[encidx].codepage;
	if (cpage == UCIO_UTF16) {
		aEnc = TEncoding::Unicode;
	} else if (cpage == UCIO_UTF16BE) {
		aEnc = TEncoding::BigEndianUnicode;
	} else {
		aEnc = TEncoding::GetEncoding(cpage);
		bEnc = aEnc;
	}

	UnicodeString s;
	TFileStream *fs = NULL;
	try {
		fs = new TFileStream(filename, fmCreate);
		for (int row = 1; row <= maxrow; row++) {
			s.SetLength(0);
			for (int col = 1; col <= maxcol; col++) {
				if (col != 1)
					s += UnicodeString(SepChar);
				s += EscapeText(Cells[col][row]);
			}
			s += EndOfLine;
			TBytes buf = aEnc->GetBytes(s);
			if (fs->Write(&buf[0], buf.Length) != buf.Length)
				throw _T("Write Error");
		}
	}
	catch (EFCreateError &e) {
		ShowMessage(e.Message);
	}
	catch (EFOpenError &e) {
		ShowMessage(e.Message);
	}
	catch (const TCHAR *e) {
		ShowMessage(e);
	}
	catch (int e) {
		ShowMessage(e);
	}
	catch (...) {
		ShowMessage(_T("File Write Error"));
	}
	if (fs != NULL) {
		rtn = fs->Size;
		delete fs;
	}
	if (bEnc != NULL)
		delete bEnc;
	return rtn;
}
//---------------------------------------------------------------------------
void __fastcall TCsvGrid::SetEncoding(TOpenTextFileDialog *dlg)
{
	dlg->Encodings->Clear();
	for (int i = 0; i < st_num_enc_tab; i++) {
		dlg->Encodings->Add(st_enc_tab[i].str);
	}
	dlg->Encodings->Add(_T(""));
	dlg->EncodingIndex = st_num_enc_tab;
}
//---------------------------------------------------------------------------
void __fastcall TCsvGrid::SetEncoding(TSaveTextFileDialog *dlg)
{
	dlg->Encodings->Clear();
	for (int i = 0; i < st_num_enc_tab; i++) {
		dlg->Encodings->Add(st_enc_tab[i].str);
	}
	dlg->EncodingIndex = 0;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
